##############################################################################
#
# FFP - Aufgabe 3
#
#         GNUPLOT-Skript fuer Einzelbild-Darstellung
#
##############################################################################

#######################
# Grafische Parameter #
#######################
set term postscript portrait "Helvetica" 12   
                                # Ausgabe in Postscript-File
set output 'out.ps'             # Name des Ausgabefiles
set nokey                       # Unterdrueckung der Legende
set title "title"               # Titel des Plots
set label 1 "t = " at -70,60    # Beschriftung des Zeitpunktes
set xlabel "x [LE]" 0,0         # Beschriftung der Achsen: x
set ylabel "y [LE]" 0,0         #                          y
set xrange [-80:80]             # Festlegung der Achsenabschnitte: x
set yrange [-80:80]             #                                  y
set size 1,0.71                 # Bildgroesse
set origin 0,0.2                # Positionierung des Bildes 

####################
# Modell-Parameter #
####################
n=300				# Anzahl der Testteilchen (beide Galaxien)
i=100                             # Bildnummer

###########################################################
# Umrechnung der Bildnummer in Zeilennummer im Daten-File #
###########################################################
irow=(i-1)*n+3*i

#################################################################
# Ploten der Daten des i-ten Bildes aus dem File 'test.bin.asc' #
#################################################################
plot 'test.bin.asc' every ::irow::(irow+n-1) using ($1*1):($2*1) with dots