##############################################################################
#
# FFP - Aufgabe 3
#
#         GNUPLOT-Skript fuer Multibild-Darstellung (6 Bilder)
#
##############################################################################

#######################
# Grafische Parameter #
#######################
set term postscript portrait "Helvetica" 12   
                                # Ausgabe in Postscript-File
set output 'out.ps'             # Name des Ausgabefiles
set nokey                       # Unterdrueckung der Legende
set xlabel "x [LE]" 0,0         # Beschriftung der Achsen: x
set ylabel "y [LE]" 0,0         #                          y
set xrange [-80:80]             # Festlegung der Achsenabschnitte: x
set yrange [-80:80]             #                                  y
set size 0.5,0.35               # Bildgroesse

####################
# Modell-Parameter #
####################
n=300				# Anzahl der Testteilchen (beide Galaxien)
i1=1                            # Bildnummer 1.
i2=50                           # Bildnummer 2.
i3=100                          # Bildnummer 3.
i4=150                          # Bildnummer 4.
i5=200                          # Bildnummer 5.
i6=220                          # Bildnummer 6.

#############################################################
# Umrechnung der Bildnummern in Zeilennummern im Daten-File #
#############################################################
i1row=(i1-1)*n+3*i1
i2row=(i2-1)*n+3*i2
i3row=(i3-1)*n+3*i3
i4row=(i4-1)*n+3*i4
i5row=(i5-1)*n+3*i5
i6row=(i6-1)*n+3*i6

#################################################################
# Ploten der Daten des i-ten Bildes aus dem File 'test.bin.asc' #
#################################################################

set multiplot                        # Aktivierung des Multiplot-Modus

###########
# 1. Bild #
###########
set origin -0.05,0.7                 # Positionierung des Bildes 
set title "title 1"                  # Titel des Plots
set label 1 "t = " at -70,60         # Beschriftung des Zeitpunktes
plot 'test.bin.asc' every ::i1row::(i1row+n-1) using ($1*1):($2*1) with dots

###########
# 2. Bild #
###########
set origin 0.5,0.7                   # Positionierung des Bildes
set title "title 2"                  # Titel des Plots
set label 2 "t = " at -70,60         # Beschriftung des Zeitpunktes
plot 'test.bin.asc' every ::i2row::(i2row+n-1) using ($1*1):($2*1) with dots

###########
# 3. Bild #
###########
set origin -0.05,0.35                # Positionierung des Bildes 
set title "title 3"                  # Titel des Plots
set label 3 "t = " at -70,60         # Beschriftung des Zeitpunktes
plot 'test.bin.asc' every ::i3row::(i3row+n-1) using ($1*1):($2*1) with dots

###########
# 4. Bild #
###########
set origin 0.5,0.35                  # Positionierung des Bildes 
set title "title 4"                  # Titel des Plots
set label 4 "t = " at -70,60         # Beschriftung des Zeitpunktes
plot 'test.bin.asc' every ::i4row::(i4row+n-1) using ($1*1):($2*1) with dots

###########
# 5. Bild #
###########
set origin -0.05,0                   # Positionierung des Bildes 
set title "title 5"                  # Titel des Plots
set label 5 "t = " at -70,60         # Beschriftung des Zeitpunktes
plot 'test.bin.asc' every ::i5row::(i5row+n-1) using ($1*1):($2*1) with dots

###########
# 6. Bild #
###########
set origin 0.5,0                     # Positionierung des Bildes 
set title "title 6"                  # Titel des Plots
set label 6 "t = " at -70,60         # Beschriftung des Zeitpunktes
plot 'test.bin.asc' every ::i6row::(i6row+n-1) using ($1*1):($2*1) with dots

set nomultiplot                      # Deaktivierung des Multiplot-Modus


